/* meshCSR.c */
/* Fortran interface file */

/*
* This file was generated automatically by bfort from the C source
* file.  
 */

#ifdef PETSC_USE_POINTER_CONVERSION
#if defined(__cplusplus)
extern "C" { 
#endif 
extern void *PetscToPointer(void *);
extern int PetscFromPointer(void *);
extern void PetscRmPointer(void *);
#if defined(__cplusplus)
} 
#endif 

#else

#define PetscToPointer(a) (*(long *)(a))
#define PetscFromPointer(a) (long)(a)
#define PetscRmPointer(a)
#endif

#include "petscfix.h"
#include "mesh.h"
#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshcreatelocalcsr_ PMESHCREATELOCALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshcreatelocalcsr_ pmeshcreatelocalcsr
#else
#define meshcreatelocalcsr_ pmeshcreatelocalcsr_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshcreatelocalcsr_ MESHCREATELOCALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshcreatelocalcsr_ meshcreatelocalcsr
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshdestroylocalcsr_ PMESHDESTROYLOCALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshdestroylocalcsr_ pmeshdestroylocalcsr
#else
#define meshdestroylocalcsr_ pmeshdestroylocalcsr_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshdestroylocalcsr_ MESHDESTROYLOCALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshdestroylocalcsr_ meshdestroylocalcsr
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshcreatefullcsr_ PMESHCREATEFULLCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshcreatefullcsr_ pmeshcreatefullcsr
#else
#define meshcreatefullcsr_ pmeshcreatefullcsr_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshcreatefullcsr_ MESHCREATEFULLCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshcreatefullcsr_ meshcreatefullcsr
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshdestroyfullcsr_ PMESHDESTROYFULLCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshdestroyfullcsr_ pmeshdestroyfullcsr
#else
#define meshdestroyfullcsr_ pmeshdestroyfullcsr_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshdestroyfullcsr_ MESHDESTROYFULLCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshdestroyfullcsr_ meshdestroyfullcsr
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshcreatedualcsr_ PMESHCREATEDUALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshcreatedualcsr_ pmeshcreatedualcsr
#else
#define meshcreatedualcsr_ pmeshcreatedualcsr_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshcreatedualcsr_ MESHCREATEDUALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshcreatedualcsr_ meshcreatedualcsr
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshdestroydualcsr_ PMESHDESTROYDUALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshdestroydualcsr_ pmeshdestroydualcsr
#else
#define meshdestroydualcsr_ pmeshdestroydualcsr_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define meshdestroydualcsr_ MESHDESTROYDUALCSR
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define meshdestroydualcsr_ meshdestroydualcsr
#endif
#endif



/* Definitions of Fortran Wrapper routines */
#if defined(__cplusplus)
extern "C" {
#endif
void PETSC_STDCALL meshcreatelocalcsr_(Mesh mesh,int *numVertices,int *numEdges,int **vertOffsets,int **vertNeighbors,
                       double **vertCoords,int *numBC,int *bcNodes,PetscTruth *symmetric, int *ierr ){
*ierr = MeshCreateLocalCSR(
	(Mesh)PetscToPointer( (mesh) ),numVertices,numEdges,vertOffsets,vertNeighbors,vertCoords,*numBC,bcNodes,*symmetric);
}
void PETSC_STDCALL meshdestroylocalcsr_(Mesh mesh,int *vertOffsets,int *vertNeighbors,double *vertCoords, int *ierr ){
*ierr = MeshDestroyLocalCSR(
	(Mesh)PetscToPointer( (mesh) ),vertOffsets,vertNeighbors,vertCoords);
}
void PETSC_STDCALL meshcreatefullcsr_(Mesh mesh,PetscTruth *constrain,int *numVertices,int *numEdges,int **vertOffsets,int **vertNeighbors, int *ierr ){
*ierr = MeshCreateFullCSR(
	(Mesh)PetscToPointer( (mesh) ),*constrain,numVertices,numEdges,vertOffsets,vertNeighbors);
}
void PETSC_STDCALL meshdestroyfullcsr_(Mesh mesh,int *vertOffsets,int *vertNeighbors, int *ierr ){
*ierr = MeshDestroyFullCSR(
	(Mesh)PetscToPointer( (mesh) ),vertOffsets,vertNeighbors);
}
void PETSC_STDCALL meshcreatedualcsr_(Mesh mesh,int **elemOffsets,int **elemNeighbors,int **edgeWeights,int *weight, int *ierr ){
*ierr = MeshCreateDualCSR(
	(Mesh)PetscToPointer( (mesh) ),elemOffsets,elemNeighbors,edgeWeights,*weight);
}
void PETSC_STDCALL meshdestroydualcsr_(Mesh mesh,int *elemOffsets,int *elemNeighbors,int *edgeWeights, int *ierr ){
*ierr = MeshDestroyDualCSR(
	(Mesh)PetscToPointer( (mesh) ),elemOffsets,elemNeighbors,edgeWeights);
}
#if defined(__cplusplus)
}
#endif
