/* sles.c */
/* Fortran interface file */

/*
* This file was generated automatically by bfort from the C source
* file.  
 */

#ifdef PETSC_USE_POINTER_CONVERSION
#if defined(__cplusplus)
extern "C" { 
#endif 
extern void *PetscToPointer(void *);
extern int PetscFromPointer(void *);
extern void PetscRmPointer(void *);
#if defined(__cplusplus)
} 
#endif 

#else

#define PetscToPointer(a) (*(long *)(a))
#define PetscFromPointer(a) (long)(a)
#define PetscRmPointer(a)
#endif

#include "petscfix.h"
#include "petscsles.h"
#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetfromoptions_ PSLESSETFROMOPTIONS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetfromoptions_ pslessetfromoptions
#else
#define slessetfromoptions_ pslessetfromoptions_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetfromoptions_ SLESSETFROMOPTIONS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetfromoptions_ slessetfromoptions
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetup_ PSLESSETUP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetup_ pslessetup
#else
#define slessetup_ pslessetup_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetup_ SLESSETUP
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetup_ slessetup
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessolve_ PSLESSOLVE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessolve_ pslessolve
#else
#define slessolve_ pslessolve_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessolve_ SLESSOLVE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessolve_ slessolve
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessolvetranspose_ PSLESSOLVETRANSPOSE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessolvetranspose_ pslessolvetranspose
#else
#define slessolvetranspose_ pslessolvetranspose_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessolvetranspose_ SLESSOLVETRANSPOSE
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessolvetranspose_ slessolvetranspose
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetoperators_ PSLESSETOPERATORS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetoperators_ pslessetoperators
#else
#define slessetoperators_ pslessetoperators_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetoperators_ SLESSETOPERATORS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetoperators_ slessetoperators
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetuponblocks_ PSLESSETUPONBLOCKS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetuponblocks_ pslessetuponblocks
#else
#define slessetuponblocks_ pslessetuponblocks_
#endif
#else
#ifdef PETSC_HAVE_FORTRAN_CAPS
#define slessetuponblocks_ SLESSETUPONBLOCKS
#elif !defined(PETSC_HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define slessetuponblocks_ slessetuponblocks
#endif
#endif



/* Definitions of Fortran Wrapper routines */
#if defined(__cplusplus)
extern "C" {
#endif
void PETSC_STDCALL slessetfromoptions_(SLES sles, int *ierr ){
*ierr = SLESSetFromOptions(
	(SLES)PetscToPointer( (sles) ));
}
void PETSC_STDCALL slessetup_(SLES sles,Vec b,Vec x, int *ierr ){
*ierr = SLESSetUp(
	(SLES)PetscToPointer( (sles) ),
	(Vec)PetscToPointer( (b) ),
	(Vec)PetscToPointer( (x) ));
}
void PETSC_STDCALL slessolve_(SLES sles,Vec b,Vec x,int *its, int *ierr ){
*ierr = SLESSolve(
	(SLES)PetscToPointer( (sles) ),
	(Vec)PetscToPointer( (b) ),
	(Vec)PetscToPointer( (x) ),its);
}
void PETSC_STDCALL slessolvetranspose_(SLES sles,Vec b,Vec x,int *its, int *ierr ){
*ierr = SLESSolveTranspose(
	(SLES)PetscToPointer( (sles) ),
	(Vec)PetscToPointer( (b) ),
	(Vec)PetscToPointer( (x) ),its);
}
void PETSC_STDCALL slessetoperators_(SLES sles,Mat Amat,Mat Pmat,MatStructure *flag, int *ierr ){
*ierr = SLESSetOperators(
	(SLES)PetscToPointer( (sles) ),
	(Mat)PetscToPointer( (Amat) ),
	(Mat)PetscToPointer( (Pmat) ),*flag);
}
void PETSC_STDCALL slessetuponblocks_(SLES sles, int *ierr ){
*ierr = SLESSetUpOnBlocks(
	(SLES)PetscToPointer( (sles) ));
}
#if defined(__cplusplus)
}
#endif
